SystemOrganization addCategory: #NewClassOrganizer!

Error subclass: #ProtocolRemovaleException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewClassOrganizer'!

!ProtocolRemovaleException commentStamp: '<historical>' prior: 0!
A ProtocolRemovaleException is an error raised when someone try to remove a protocol that should not be removed!

Object subclass: #ClassOrganization
	instanceVariableNames: 'comment commentStamp protocolOrganizer organizedClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewClassOrganizer'!

!ClassOrganization commentStamp: '<historical>' prior: 0!
A ClassOrganization is a new implementation of ClassOrganizer with 
	- cleaner API
	- better object management
	- better categorization
	
This object is in charge of system notifications.
It manages the class comment, the class comment stamp and a protocol organizer!

!ClassOrganization class methodsFor: 'import' stamp: 'BenjaminVanRyseghem 4/24/2012 14:11'!
importFrom: aClassOrganizer
	
	aClassOrganizer class = self
		ifTrue: [ ^ aClassOrganizer ].
		
	^ self new
		importFrom: aClassOrganizer;
		yourself! !

!ClassOrganization methodsFor: 'backward compatibility' stamp: 'BenjaminVanRyseghem 4/12/2012 15:42'!
addCategory: aProtocolName before: aUselessArgument

	self protocolOrganizer addProtocolNamed: aProtocolName! !

!ClassOrganization methodsFor: 'backward compatibility' stamp: 'BenjaminVanRyseghem 4/24/2012 14:17'!
allMethodSelectors
	
	^ protocolOrganizer allMethods! !

!ClassOrganization methodsFor: 'protocol - forward' stamp: 'BenjaminVanRyseghem 4/12/2012 16:55'!
categories

	^ self protocolOrganizer protocolsNames! !

!ClassOrganization methodsFor: 'protocol - forward' stamp: 'BenjaminVanRyseghem 4/12/2012 16:45'!
categoriesSorted

	^ self protocolOrganizer protocolsSorted! !

!ClassOrganization methodsFor: 'backward compatibility' stamp: 'BenjaminVanRyseghem 4/12/2012 15:25'!
categoryOfElement: aSelector

	^ (self protocolOrganizer protocolsOfSelector: aSelector)
		ifEmpty: [ Protocol defaultName ]
		ifNotEmpty: [:col | col first name ]! !

!ClassOrganization methodsFor: 'backward compatibility - file in/out' stamp: 'BenjaminVanRyseghem 4/12/2012 18:11'!
changeFromCategorySpecs: categorySpecs

	"notification"
	self internalChangeFromString: categorySpecs! !

!ClassOrganization methodsFor: 'backward compatibility - file in/out' stamp: 'BenjaminVanRyseghem 4/12/2012 18:29'!
changeFromString: aString 
	"Parse the argument, aString, and make this be the receiver's structure."

	| categorySpecs |
	categorySpecs := Scanner new scanTokens: aString.
	
	"If nothing was scanned and I had no elements before, then default me"
	(categorySpecs isEmpty and: [ self protocolOrganizer isEmpty ])
		ifTrue: [ ^ self protocolOrganizer reset ].

	^ self changeFromCategorySpecs: categorySpecs! !

!ClassOrganization methodsFor: 'backward compatibility' stamp: 'BenjaminVanRyseghem 4/12/2012 15:02'!
classComment

	^ self comment! !

!ClassOrganization methodsFor: 'backward compatibility' stamp: 'BenjaminVanRyseghem 4/12/2012 15:03'!
classComment: aString

	self comment: aString! !

!ClassOrganization methodsFor: 'backward compatibility' stamp: 'BenjaminVanRyseghem 4/12/2012 18:36'!
classComment: aString stamp: aStamp

	self
		comment: aString;
		commentStamp: aStamp! !

!ClassOrganization methodsFor: 'backward compatibility' stamp: 'BenjaminVanRyseghem 4/12/2012 15:51'!
classify: aSymbol under: aProtocolName

	^ self 
		classify: aSymbol
		under: aProtocolName
		suppressIfDefault: true! !

!ClassOrganization methodsFor: 'backward compatibility' stamp: 'BenjaminVanRyseghem 4/12/2012 15:45'!
classify: aMethod under: aProtocolName suppressIfDefault: aBoolean

	^ self protocolOrganizer 
			classify: aMethod 
			inProtocolNamed: aProtocolName 
			suppressIfDefault: aBoolean! !

!ClassOrganization methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2012 18:39'!
comment

	comment ifNil: [^ ''].
	^ comment string ifNil: ['']! !

!ClassOrganization methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2012 18:37'!
comment: aString 
	"Store the comment, aString, associated with the object that refers to the 
	receiver."

	(aString isKindOf: RemoteString) 
		ifTrue: [ comment := aString]
		ifFalse: [aString isEmptyOrNil
			ifTrue: [ comment := nil]
			ifFalse: [
				comment := RemoteString newString: aString onFileNumber: 2]]
				"Later add priorSource and date and initials?"! !

!ClassOrganization methodsFor: 'backward compatibility' stamp: 'BenjaminVanRyseghem 4/12/2012 18:41'!
commentRemoteStr

	^ comment! !

!ClassOrganization methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2012 15:04'!
commentStamp
	^ commentStamp! !

!ClassOrganization methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2012 15:04'!
commentStamp: anObject
	commentStamp := anObject! !

!ClassOrganization methodsFor: 'backward compatibility' stamp: 'BenjaminVanRyseghem 4/12/2012 16:15'!
hasSubject

	^ organizedClass notNil! !

!ClassOrganization methodsFor: 'importing' stamp: 'BenjaminVanRyseghem 4/12/2012 18:29'!
importFrom: aClassOrganizer 
	
	organizedClass := aClassOrganizer subject.
	self comment: aClassOrganizer classComment.
	self commentStamp: aClassOrganizer commentStamp.
	
	protocolOrganizer := (ProtocolOrganizer importFrom: aClassOrganizer)! !

!ClassOrganization methodsFor: 'backward compatibility - file in/out' stamp: 'BenjaminVanRyseghem 4/13/2012 13:46'!
internalChangeFromString: categorySpecs 
	"Parse the argument, aString, and make this be the receiver's structure."

	protocolOrganizer := ProtocolOrganizer fromSpec: categorySpecs! !

!ClassOrganization methodsFor: 'protocol - forward' stamp: 'BenjaminVanRyseghem 4/12/2012 16:02'!
listAtCategoryNamed: aName

	^ (self protocolOrganizer methodsInProtocolNamed: aName) asArray! !

!ClassOrganization methodsFor: 'backward compatibility' stamp: 'BenjaminVanRyseghem 4/24/2012 14:18'!
listAtCategoryNumber: aSmallInteger 
	
	^ (protocolOrganizer allProtocols at: aSmallInteger ifAbsent: [ ^ {} ]) methods asArray! !

!ClassOrganization methodsFor: 'notifications' stamp: 'SeanDeNigris 9/5/2012 19:55'!
notifyOfChangedCategoriesFrom: oldCollectionOrNil to: newCollectionOrNil
	(self hasSubject and: [oldCollectionOrNil ~= newCollectionOrNil]) 
		ifTrue: [SystemAnnouncer uniqueInstance classReorganized: self subject].! !

!ClassOrganization methodsFor: 'notifications' stamp: 'SeanDeNigris 9/5/2012 19:55'!
notifyOfChangedCategoryFrom: oldNameOrNil to: newNameOrNil
	(self hasSubject and: [oldNameOrNil ~= newNameOrNil]) 
		ifTrue: [SystemAnnouncer uniqueInstance classReorganized: self subject].! !

!ClassOrganization methodsFor: 'notifications' stamp: 'BenjaminVanRyseghem 4/12/2012 15:54'!
notifyOfChangedSelector: element from: oldCategory to: newCategory
	(self hasSubject and: [(oldCategory ~= newCategory)]) ifTrue: [
		self subject notifyOfRecategorizedSelector: element from: oldCategory to: newCategory.
	].! !

!ClassOrganization methodsFor: 'notifications' stamp: 'BenjaminVanRyseghem 4/12/2012 15:54'!
notifyOfChangedSelectorsOldDict: oldDictionaryOrNil newDict: newDictionaryOrNil
	(oldDictionaryOrNil isNil and: [newDictionaryOrNil isNil])
		ifTrue: [^ self].
		
	oldDictionaryOrNil isNil ifTrue: [
	newDictionaryOrNil keysAndValuesDo: [:el :cat |
		self notifyOfChangedSelector: el from: nil to: cat].
		^ self.
	].

	newDictionaryOrNil isNil ifTrue: [
	oldDictionaryOrNil keysAndValuesDo: [:el :cat |
		self notifyOfChangedSelector: el from: cat to: nil].
		^ self.
	].
		
	oldDictionaryOrNil keysAndValuesDo: [:el :cat | | newCat |
		newCat := newDictionaryOrNil at: el.
		self notifyOfChangedSelector: el from: cat to: newCat.
	].! !

!ClassOrganization methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2012 15:52'!
organizedClass
	^ organizedClass! !

!ClassOrganization methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2012 15:01'!
protocolOrganizer
	
	^ protocolOrganizer! !

!ClassOrganization methodsFor: 'backward compatibility' stamp: 'BenjaminVanRyseghem 4/12/2012 16:04'!
removeCategory: aProtocolName
	| oldCategories |
	
	oldCategories := self protocolOrganizer allProtocolsNames copy.
	self protocolOrganizer removeProtocolNamed: aProtocolName.
	self notifyOfChangedCategoriesFrom: oldCategories to: self protocolOrganizer allProtocolsNames.! !

!ClassOrganization methodsFor: 'backward compatibility' stamp: 'BenjaminVanRyseghem 4/24/2012 14:38'!
removeElement: aSymbol
	| oldCat |
	
	oldCat := self categoryOfElement: aSymbol.
	self protocolOrganizer removeMethod: aSymbol.
	self notifyOfChangedSelector: aSymbol from: oldCat to: (self categoryOfElement: aSymbol).! !

!ClassOrganization methodsFor: 'backward compatibility' stamp: 'BenjaminVanRyseghem 4/24/2012 14:38'!
removeEmptyCategories
	| oldCategories |
	
	oldCategories := self protocolOrganizer allProtocolsNames copy.
	self protocolOrganizer removeEmptyProtocols.
	self notifyOfChangedCategoriesFrom: oldCategories to: self protocolOrganizer allProtocolsNames.! !

!ClassOrganization methodsFor: 'backward compatibility' stamp: 'BenjaminVanRyseghem 4/12/2012 16:20'!
renameCategory: oldName toBe: newName

	self protocolOrganizer 
		renameProtocol: oldName
		into: newName.
		
	self notifyOfChangedCategoryFrom: oldName to: newName.! !

!ClassOrganization methodsFor: 'backward compatibility - file in/out' stamp: 'BenjaminVanRyseghem 4/12/2012 18:29'!
scanFrom: aStream
	"Reads in the organization from the next chunk on aStream.
	Categories or elements not found in the definition are not affected.
	New elements are ignored."

	self changeFromString: aStream nextChunk.
	aStream skipStyleChunk.! !

!ClassOrganization methodsFor: 'backward compatibility' stamp: 'BenjaminVanRyseghem 4/12/2012 16:15'!
setSubject: anObject
	
	organizedClass := anObject! !

!ClassOrganization methodsFor: 'backward compatibility' stamp: 'BenjaminVanRyseghem 4/24/2012 14:40'!
sortCategories! !

!ClassOrganization methodsFor: 'backward compatibility - file in/out' stamp: 'BenjaminVanRyseghem 4/12/2012 18:10'!
stringForFileOut

	^ self protocolOrganizer stringForFileOut! !

!ClassOrganization methodsFor: 'backward compatibility' stamp: 'BenjaminVanRyseghem 4/12/2012 16:18'!
subject

	^organizedClass! !

Object subclass: #Protocol
	instanceVariableNames: 'methods name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewClassOrganizer'!

!Protocol commentStamp: '<historical>' prior: 0!
A Protocol is a simple value holder representing a protocol.
It's composed of a name and a set of method selectors!

Protocol subclass: #AllProtocol
	instanceVariableNames: 'protocolOrganizer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewClassOrganizer'!

!AllProtocol commentStamp: '<historical>' prior: 0!
An AllProtocol is a special protocol to hanlde the "all" case!

!AllProtocol class methodsFor: 'data' stamp: 'BenjaminVanRyseghem 4/12/2012 15:49'!
defaultName

	^ '~~~ all ~~~'! !

!AllProtocol class methodsFor: 'data' stamp: 'BenjaminVanRyseghem 4/12/2012 14:42'!
nullCategory

	^ 'no method'! !

!AllProtocol class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 4/12/2012 14:14'!
protocolOrganizer: protocolOrganizer

	^ self new
		protocolOrganizer: protocolOrganizer;
		yourself! !

!AllProtocol methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/12/2012 16:05'!
canBeRemoved
	
	^ false! !

!AllProtocol methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2012 14:15'!
methods

	^ self protocolOrganizer allMethods! !

!AllProtocol methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 14:50'!
name

	^ (self methods isEmpty and: [ protocolOrganizer protocols isEmpty])
		ifTrue: [ self class nullCategory ]
		ifFalse: [ name ]! !

!AllProtocol methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2012 14:15'!
protocolOrganizer
	
	^ protocolOrganizer! !

!AllProtocol methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2012 14:15'!
protocolOrganizer: anObject
	
	protocolOrganizer := anObject.! !

!Protocol class methodsFor: 'data' stamp: 'BenjaminVanRyseghem 4/12/2012 14:38'!
defaultName

	^  #'as yet unclassified'! !

!Protocol class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 4/12/2012 14:06'!
name: nm

	^ self new
		name: nm;
		yourself! !

!Protocol class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 4/12/2012 14:02'!
name: nm methods: methods 

	^ self new
		methods: methods;
		name: nm;
		yourself! !

!Protocol methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/12/2012 14:11'!
addMethod: aSymbol

	^ methods add: aSymbol! !

!Protocol methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/12/2012 16:05'!
canBeRemoved
	
	^ true! !

!Protocol methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/12/2012 14:11'!
includesMethod: aSymbol

	^ methods includes: aSymbol! !

!Protocol methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 4/12/2012 14:38'!
initialize
	"Initialization code for Protocol"

	super initialize.

	methods := IdentitySet new..
	name := self class defaultName.! !

!Protocol methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/12/2012 16:27'!
isEmpty

	^ self methods isEmpty! !

!Protocol methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2012 14:21'!
methods

	^ methods! !

!Protocol methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2012 14:02'!
methods: anObject
	
	methods := anObject! !

!Protocol methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2012 14:21'!
name

	^ name! !

!Protocol methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2012 14:02'!
name: anObject
	
	name := anObject! !

!Protocol methodsFor: 'printing' stamp: 'BenjaminVanRyseghem 4/12/2012 14:28'!
printOn: aStream

	aStream 
		nextPutAll: (self class name);
		nextPutAll: ' (';
		nextPutAll: (self name);
		nextPutAll: ') - ';
		nextPutAll: (self methods size asString);
		nextPutAll: ' selector(s)'.! !

!Protocol methodsFor: '~~~ all ~~~' stamp: 'BenjaminVanRyseghem 4/12/2012 14:11'!
removeMethod: aSymbol

	^ methods remove: aSymbol! !

!Protocol methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/12/2012 14:12'!
rename: newName

	self name: newName! !

Object subclass: #ProtocolOrganizer
	instanceVariableNames: 'allProtocol protocols'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewClassOrganizer'!

!ProtocolOrganizer commentStamp: '<historical>' prior: 0!
A ProtocolOrganizer is part of a ClassOrganizer.

It manages the protocols of the class that owns it!

!ProtocolOrganizer class methodsFor: 'import' stamp: 'BenjaminVanRyseghem 4/13/2012 13:45'!
fromSpec: aSpec
	
	^ self new
		fromSpec: aSpec;
		yourself! !

!ProtocolOrganizer class methodsFor: 'import' stamp: 'BenjaminVanRyseghem 4/12/2012 14:35'!
importFrom: aClassOrganizer
	
	^ self new
		importFrom: aClassOrganizer;
		yourself! !

!ProtocolOrganizer methodsFor: 'protocol - adding' stamp: 'BenjaminVanRyseghem 4/12/2012 14:11'!
addProtocol: aProtocol

	^ protocols add: aProtocol! !

!ProtocolOrganizer methodsFor: 'protocol - adding' stamp: 'BenjaminVanRyseghem 4/12/2012 14:11'!
addProtocolNamed: aName

	^ protocols add: (Protocol name: aName)! !

!ProtocolOrganizer methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/12/2012 14:17'!
allMethods

	^ self protocols gather: [:p | p methods ].! !

!ProtocolOrganizer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2012 14:19'!
allProtocol

	^ allProtocol! !

!ProtocolOrganizer methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/12/2012 15:10'!
allProtocols

	^ { allProtocol }, protocols asArray! !

!ProtocolOrganizer methodsFor: 'backward compatibility' stamp: 'BenjaminVanRyseghem 4/12/2012 15:12'!
allProtocolsNames

	^ self allProtocols collect: #name! !

!ProtocolOrganizer methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/24/2012 15:10'!
classify: aSymbol inProtocolNamed: aProtocolName 
	| name protocol |
	
	name := aProtocolName.
	name = allProtocol name
		ifTrue: [ name := Protocol defaultName ].
		
	"maybe here we should check if this method already belong to another protocol"
	(self protocolsOfSelector: aSymbol) do: [:p | p removeMethod: aSymbol ].
	protocol := self getProtocolNamed: name ifNone: [ self addProtocolNamed: name ].
	
	protocol addMethod: aSymbol
	! !

!ProtocolOrganizer methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/24/2012 15:10'!
classify: aSymbol inProtocolNamed: aProtocolName suppressIfDefault: aBoolean
	| protocolsToRemove |

	protocolsToRemove := {}.
	aBoolean ifTrue: [
		protocolsToRemove := self protocolsOfSelector: aSymbol ].
	protocolsToRemove do: [:e | self removeProtocol: e ].
	
	self 
		classify: aSymbol 
		inProtocolNamed: aProtocolName.
		
	! !

!ProtocolOrganizer methodsFor: 'importing' stamp: 'BenjaminVanRyseghem 4/13/2012 13:45'!
fromSpec: aSpec
	
	aSpec do: [:spec || name methods |
		name := spec first asSymbol.
		methods := spec allButFirst asSet.
		self addProtocol: (Protocol 
								name: name
								methods: methods) ]! !

!ProtocolOrganizer methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/12/2012 15:39'!
getProtocolNamed: aName

	^ self allProtocols detect: [ :e | e name = aName ] ifNone: [ self allProtocol ]! !

!ProtocolOrganizer methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/24/2012 14:16'!
getProtocolNamed: aByteString ifNone: aBlockClosure 
	
	^ protocols detect: [:e | e name = aByteString ] ifNone: aBlockClosure ! !

!ProtocolOrganizer methodsFor: 'importing' stamp: 'BenjaminVanRyseghem 4/12/2012 18:15'!
importFrom: aClassOrganizer 
	
	aClassOrganizer categories do: [:cat || protocol methods |
		cat = ClassOrganizer nullCategory
			ifFalse: [
				methods := aClassOrganizer listAtCategoryNamed: cat. 
				protocol := self addProtocolNamed: cat asString.
				methods do: [:m |
					protocol  addMethod: m ]]].! !

!ProtocolOrganizer methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 4/12/2012 14:36'!
initialize
	"Initialization code for ProtocolOrganizer"

	super initialize.

	protocols := IdentitySet new.
	allProtocol := AllProtocol protocolOrganizer: self.! !

!ProtocolOrganizer methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/12/2012 15:10'!
methodsInProtocolNamed: aName

	^ (self getProtocolNamed: aName) methods! !

!ProtocolOrganizer methodsFor: 'backward compatibility' stamp: 'BenjaminVanRyseghem 4/12/2012 16:55'!
protocols

	^ protocols! !

!ProtocolOrganizer methodsFor: 'backward compatibility' stamp: 'BenjaminVanRyseghem 4/12/2012 16:55'!
protocolsNames

	^ self allProtocolsNames! !

!ProtocolOrganizer methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/12/2012 15:19'!
protocolsOfSelector: aSelector

	^ (self protocols select: [:e | e includesMethod: aSelector ]) asArray! !

!ProtocolOrganizer methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/12/2012 16:56'!
protocolsSorted

	^ { allProtocol name }, (self protocols collect: #name) asArray sort! !

!ProtocolOrganizer methodsFor: 'protocol - removing' stamp: 'BenjaminVanRyseghem 4/24/2012 14:38'!
removeEmptyProtocols
	
	(self protocols select: [:e | e isEmpty and: [ e canBeRemoved ] ]) 
		do: [:p | self removeProtocol: p ]! !

!ProtocolOrganizer methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/24/2012 14:38'!
removeMethod: aSymbol

	(self protocolsOfSelector: aSymbol) do: [ :p | p removeMethod: aSymbol ]! !

!ProtocolOrganizer methodsFor: 'protocol - removing' stamp: 'BenjaminVanRyseghem 4/24/2012 14:37'!
removeProtocol: aProtocol

	aProtocol canBeRemoved
		ifFalse: [ ProtocolRemovaleException signal ].
	
	^ protocols remove: aProtocol! !

!ProtocolOrganizer methodsFor: 'protocol - removing' stamp: 'BenjaminVanRyseghem 4/24/2012 14:38'!
removeProtocolNamed: aName
	| protocolToRemove |
	
	protocolToRemove := self getProtocolNamed: aName.
	^ self removeProtocol: protocolToRemove! !

!ProtocolOrganizer methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/12/2012 16:17'!
renameProtocol: oldName into: newName

	^ (self getProtocolNamed: oldName)
			name: newName;
			yourself! !

!ProtocolOrganizer methodsFor: 'backward compatibility - file in/out' stamp: 'BenjaminVanRyseghem 4/12/2012 18:10'!
stringForFileOut

	^ String streamContents: [:aStream | 
			self protocols do: [:p | 
				aStream << $( << p name printString.
				p methods do: [:m |
					aStream << ' ' << m asString ].
				aStream << $); cr ]]! !

Object subclass: #TestClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewClassOrganizer'!

!TestClass methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 4/24/2012 15:11'!
foo! !
